"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const file_1 = require("../file");
const imageUtil_1 = require("../util/imageUtil");
function fromInputFileElement(a) {
    return __awaiter(this, void 0, void 0, function* () {
        const files = yield file_1.File.fromHtmlFileInputElement(a);
        return files.map(f => f.asMat());
    });
}
exports.fromInputFileElement = fromInputFileElement;
function fetchImageData(url) {
    return new Promise((resolve, reject) => {
        var img = new Image();
        img.onload = e => {
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0, img.width, img.height);
            var imgData = ctx.getImageData(0, 0, canvas.width, canvas.height);
            resolve(imgData);
        };
        img.onerror = reject;
        img.src = url;
    });
}
exports.fetchImageData = fetchImageData;
function asHtmlImageData(img) {
    var imgData = imageUtil_1.toImageData(img);
    const htmlImageData = new ImageData(imgData.data, imgData.width, imgData.height);
    return htmlImageData;
}
exports.asHtmlImageData = asHtmlImageData;
//# sourceMappingURL=imageCreation.js.map