import { FormatCodec } from '../types/mirada';
/**
  Example of declaring a format codec that uses DOM canvas instance which must be provided by the user.
  
```ts
import  jimp from 'jimp'
class JimpProxy implements FormatProxyClass {
  async create() {
   return new JimpFormatCodec(Jimp)
  }
}
```
 */
export declare class CanvasCodec implements FormatCodec {
    constructor();
    decode(buffer: ArrayBuffer, format?: string): Promise<ImageData | undefined>;
    encode(data: ImageData, format: string, quality?: number): Promise<ArrayBuffer | undefined>;
}
