import { FormatCodec } from '../types/mirada';
declare type AnyConstructor = {
    [a: string]: any;
    new (...args: any[]): any;
};
declare type Jimp = AnyConstructor;
/**
  Example of declaring a Jimp proxy as a class
  
```ts
import  jimp from 'jimp'
class JimpProxy implements FormatProxyClass {
  async create() {
   return new JimpFormatCodec(Jimp)
  }
}
```
 */
export declare class JimpCodec implements FormatCodec {
    protected jimp: Jimp;
    constructor(jimp: Jimp);
    decode(buffer: ArrayBuffer): Promise<ImageData | undefined>;
    encode(data: ImageData, format: string, quality?: number): Promise<ArrayBuffer | undefined>;
}
export {};
