import { FS } from './types/emscripten';
import { LoadOptions } from './types/mirada';
export declare const FS_ROOT = "/work";
/**
 * gets the emscripten FS API
 */
export declare function getFS(): FS;
/**
 * Loads opencv.js file. It will do it only once no matter if called multiple times.
 * In the browser a new script element is created to load the file while in Node.js
 * the file is loaded using a require() call.
 *
 * Returns a promise resolved when the library is ready or rejected if there's a problem.
 *
 * Notice that among the options users can define the location of opencv.js file, which
 * in the case of the browser it could be in an external server.
 */
export declare function loadOpencv(options?: LoadOptions): Promise<void> | Promise<FS>;
